<?php
/**
 * @version $Id$
 * @package RSGallery2
 * @copyright (C) 2003 - 2006 RSGallery2
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 */
defined( '_VALID_MOS' ) or die( 'Restricted Access' );

/**
 * Template class for RSGallery2
 * @package RSGallery2
 * @author Ronald Smit <ronald.smit@rsdev.nl>
 */

class rsgGallery_semantic extends rsgGallery {
	function rsgGallery_semantic() {
	}
	function itemRows( ){
		global $rsgConfig;
		if( $this->_itemRows === null ){
			$db = &JFactory::getDBO();

			$limit = rsgInstance::getInt( 'limit', $rsgConfig->get("display_thumbs_maxPerPage") );
			$limitstart = rsgInstance::getInt( 'limitstart', 0 );
			$filter_order = rsgInstance::getWord( 'filter_order', 'ordering' );
			$filter_order_Dir = rsgInstance::getWord( 'filter_order_Dir', 'ASC' );

			$where = ' WHERE published = 1 ';
			//if($filter_order == "rating") $filter_order = "avrating";
			if ($filter_order == 'ordering'){
				$orderby 	= ' ORDER BY ordering ';
			} else {
				$orderby 	= ' ORDER BY '.$filter_order.' '.$filter_order_Dir.' , ordering ';
			}

			$query = ' SELECT *, (rating/votes) as rating FROM #__rsgallery2_files '
				. $where
				. $orderby;

			// limits should be handled by the db, but this appears to be borked
			$db->setQuery( $query, $limitstart, $limit );
			//echo $db->getQuery();
			$this->_itemRows = $db->loadAssocList( 'id' );
		}
		return $this->_itemRows;
	}
	function itemCount(){
		if( $this->_itemCount === null ){
			global $database;

			$gid = $this->id;
			$database->setQuery("SELECT COUNT(1) FROM #__rsgallery2_files WHERE published = '1'");
			$this->_itemCount = $database->loadResult();
		}
		return $this->_itemCount;
	}
}

class rsgDisplay_semantic extends rsgDisplay{

	function mainPage(){
		global $rsgConfig, $_page, $_gid;
        //.. Begin: custom code ................
		$filter_order = rsgInstance::getWord( 'filter_order', '' );
		$_gid 	= rsgInstance::getVar('gid',0);

		$this->display( 'header.php' );
		if (isset($_REQUEST['filter_order']) && !isset($_REQUEST['gid'])) {
			//abc here
			$this->gallery = new rsgGallery_semantic();
			switch ($_REQUEST['filter_order']) {
				case 'date':
					if ($this->gallery->row['name']) {
						$this->gallery->row['name'] .= " - Latest Added";
					} else {
						$this->gallery->row['name'] = "Latest Added";
					}
					break;
				case 'hits':
					if ($this->gallery->row['name']) {
						$this->gallery->row['name'] .= " - Popular";
					} else {
						$this->gallery->row['name'] = "Popular";
					}
					break;
				case 'votes':
					if ($this->gallery->row['name']) {
						$this->gallery->row['name'] .= " - Most Voted";
					} else {
						$this->gallery->row['name'] = "Most Voted";
					}
					break;
				case 'rating':
					if ($this->gallery->row['name']) {
						$this->gallery->row['name'] .= " - Most Rating";
					} else {
						$this->gallery->row['name'] = "Most Rating";
					}
					break;
				case 'comments':
					if ($this->gallery->row['name']) {
						$this->gallery->row['name'] .= " - Most Commended";
					} else {
						$this->gallery->row['name'] = "Most Commended";
					}
					break;
				default:
					$this->gallery->row['name'] = "";
			}

			$this->display('gallery.php');
			$this->showThumbs();
		} else
			parent::mainPage();
		$this->display( 'footer.php' );
	}

	function inline(){
		$this->display( 'inline.php' );
	}

	/**
	* Show main gallery page
	* @param string Style for main page (single, double, box)
	* @param boolean Show subgalleries or not.
	* @return HTML for main gallery page.
	*/
	function showMainGalleries() {
		global $rsgConfig;
		$gallery =  rsgInstance::getGallery();
		$this->gallery = $gallery;

		//Get values for page navigation from URL
		$limit = rsgInstance::getInt( 'limit', $rsgConfig->get('galcountNrs') );
		$limitstart = rsgInstance::getInt( 'limitstart', 0 );

		//Get number of galleries including main gallery
		$this->kids = $gallery->kids();
		$kidCountTotal = count( $gallery->kids() );

		$this->pageNav = false;

		if( $rsgConfig->get('dispLimitbox') == 1 ) {
			if( $kidCountTotal > $limit ){
				$this->kids = array_slice( $this->kids, $limitstart, $limit );
				$this->pageNav = new mosPageNav( $kidCountTotal, $limitstart, $limit );
			}
		} elseif( $rsgConfig->get('dispLimitbox') == 2 ) {
			$this->kids = array_slice( $this->kids, $limitstart, $limit );
			$this->pageNav = new mosPageNav( $kidCountTotal, $limitstart, $limit );
		}

		$this->display( 'gallery.php' );

		//Show page navigation if selected in backend
	}

    /***************************
		non page public functions
	***************************/
	/**
	 * Shows the gallery details block when set in the backend
	 */
	function _showGalleryDetails( $kid ) {
		global $rsgConfig, $Itemid;
		$slideshow 	= $rsgConfig->get('displaySlideshow');
		$owner 		= $rsgConfig->get('showGalleryOwner');
		$size 		= $rsgConfig->get('showGallerySize');
		$date 		= $rsgConfig->get('showGalleryDate');

		//Check if items need to be shown
		if ( ($slideshow + $owner + $size + $date) > 0 ) {
			?>
			<div class="rsg_gallery_details">
			<div class="rsg2_details">
			<?php
			if ($slideshow) {
				?>
				<a href="#" onclick="slideshow_<?php echo $kid->get('id'); ?>();return false;"><?php echo _RSGALLERY_SLIDESHOW; ?></a><br />
				<script type="text/javascript">
				function slideshow_<?php echo $kid->get('id'); ?>(){
					var images = [];
					<?php 
					foreach( $kid->items() as $item ):
						if( $item->type != 'image' )
							continue;  // we only handle images
						$display = $item->display();
						
						$url=$display->url();
						$url=str_replace(" ","%20",$url);
						
					?>
					images.push(["<?php echo $url; ?>", "<?php echo htmlspecialchars(stripslashes($item->descr), ENT_QUOTES); ?>"]);
					<?php endforeach; ?>
					Lightbox.open(images, 0);
				}
				</script>

				<?php
			}

			if ($owner) {
				echo _RSGALLERY_TMPL_GAL_DETAILS_OWNER." "; echo $kid->owner;?><br />
				<?php
			}

			if ($size) {
				echo _RSGALLERY_TMPL_GAL_DETAILS_SIZE." "; echo galleryUtils::getFileCount($kid->get('id')). _RSGALLERY_IMAGES;?><br />
			<?php
			}

			if ($date) {
				echo _RSGALLERY_TMPL_GAL_DETAILS_DATE." "; echo mosFormatDate( $kid->date,"%d-%m-%Y" );?><br />
				<?php
			}
			?>
			</div>
			</div>
			<?php
		}
	}

    /***************************
		private functions
	***************************/

    /**
     * @todo this alternate gallery view needs to be moved to an html file and added as a template parameter
     */
    function _showDouble( $kids ) {
		global $rsgConfig;
        $i = 0;
		echo"<div class='rsg_double_fix'>";
        foreach ( $kids as $kid ) {
			$i++;
            ?>
            <div class="rsg_galleryblock_double_<?php echo $i?>">
				<div class="rsg2-galleryList-status"><?php echo $kid->status;?></div>
				<div class="rsg2-galleryList-thumb_double">
					<?php echo $kid->thumbHTML; ?>
				</div>
				<div class="rsg2-galleryList-text_double">
					<?php echo $kid->galleryName;?>
					<span class='rsg2-galleryList-newImages'>
						<sup><?php echo galleryUtils::newImages($kid->get('id')); ?></sup>
					</span>
					<?php echo $this->_showGalleryDetails( $kid );?>
					<div class="rsg2-galleryList-description"><?php echo $kid->description;?>
					</div>
				</div>
				<div class="rsg_sub_url"><?php $this->_subGalleryList( $kid ); ?>
				</div>
			</div>
            <?php
			if($i>1){
				$i = 0;
			}
        }
		echo "</div>";
    }

    /**
     * @todo this alternate gallery view needs to be moved to an html file and added as a template parameter
     */
    function _showBox( $kids, $subgalleries ) {
        ?>
		<div class="rsg_box_block">
            <?php
            $i = 0;
            foreach ( $kids as $kid ) {
                $i++;
				if($i>3){
					$i = 1;
					}
			 ?>
                <div class="rsg_box_box_<?php echo $i;?>">
                    <div class="rsg_galleryblock">
                    	<div>
							<div class="rsg2-galleryList-status"><?php echo $kid->status; ?></div>
                            <?php echo $kid->galleryName;?>
                            <sup><span class='rsg2-galleryList-newImages'><?php echo galleryUtils::newImages($kid->get('id')); ?></span></sup>
                            <div class='rsg2-galleryList-totalImages'>(<?php echo galleryUtils::getFileCount($kid->get('id')). _RSGALLERY_IMAGES;?>)</div>
                        </div>
						<div>
                        	<div class="rsg2-galleryList-thumb_box">
								<?php echo $kid->thumbHTML; ?>
                        	</div>
                        	<div class="rsg2-galleryList-text_box">
                          		<?php echo $this->_showGalleryDetails( $kid );?>
                        	</div>
                    	</div>
                        <div class="rsg2-galleryList-description_box">
                            	<?php echo $kid->description;?>
						</div>
                        <div class="rsg_sub_url"><?php $this->_subGalleryList( $kid ); ?></span>
                        </div>
                    </div>
                </div>
                <?php
            }
			?>
            </div>
        <?php
    }

	/**
	 * @todo this alternate gallery view needs to be moved to an html file and added as a template parameter
	 */
    function _showCustom( $kids, $cols, $gubgalleries ) {
        echo "<h2>For testing purposes only!</h2>";
        $width = 100/$cols."%";
        ?>
        <ul id="rsg2-galleryList">
        <table width="100%" border="1">
        <tr>
        <?php
        $i = 0;
        foreach ( $kids as $kid ) {
            $i++;
            echo "<td width=\"$width\" valign=\"top\">";
            $this->_writeCustomGalleryBlock( $kid );
            echo "</td>";
            if ($i%$cols == 0) {
                echo "</tr><tr>";
            }
        }
        ?>
        </tr>
        </table>
        </ul>
        <?php
    }

    function _writeCustomGalleryBlock( $block ) {
        global $rsgConfig;

        //Set template selection
        if (!$rsgConfig->get('template')) {
            $cur_template = "default";
        } else {
            $cur_template = $rsgConfig->get('template');
        }
        //Include gallery block template file
        include( JPATH_RSGALLERY2_SITE. DS . 'tpl' . DS . $cur_template . DS . 'galleryblock.php' );
    }

	/**
	 * Shows thumbnails for gallery
	 */
	function showThumbs() {
		global $my, $rsgConfig, $Itemid, $_gid;
/*        if (!$_gid) {
        	echo "Not found GID h";
        	return;
        }*/
		$itemCount = $this->gallery->itemCount();

		$limit = rsgInstance::getInt( 'limit', $rsgConfig->get("display_thumbs_maxPerPage") );
		$limitstart = rsgInstance::getInt( 'limitstart' );

		//instantiate page navigation
		$pagenav = new mosPageNav( $itemCount, $limitstart, $limit );

		// increase the gallery hit counter
		$this->gallery->hit();

		if( !$this->gallery->itemCount() ){
			if( $this->gallery->id ){
				// if gallery is not the root gallery display the message
				echo _RSGALLERY_NOIMG;
			}
			// no items to display, so we can return;
			return;
		}
		//Old rights management. If user is owner or user is Super Administrator, you can edit this gallery
		if(( $my->id <> 0 ) and (( $this->gallery->uid == $my->id ) OR ( $my->usertype == 'Super Administrator' )))
			$this->allowEdit = true;
		else
			$this->allowEdit = false;

		switch( $rsgConfig->get( 'display_thumbs_style' )){
			case 'float':
				$this->display( 'thumbs_float.php' );
			break;
			case 'table':
				$this->display( 'thumbs_table.php' );
			break;
		}
		?>
		<div id='rsg2-pageNav' align="center">
				<?php
				if( $itemCount > $limit ){
					global $Itemid;
					$filter_order = rsgInstance::getWord( 'filter_order', '' );
					$filter_order_Dir = rsgInstance::getWord( 'filter_order_Dir', '' );
					$link = "index.php?option=com_rsgallery2&amp;Itemid=$Itemid";
					$link .= ($this->gallery->id?"&amp;gid=".$this->gallery->id:'');
					$link .= ($filter_order?"&amp;filter_order=".$filter_order:'');
					$link .= ($filter_order_Dir?"&amp;filter_order_Dir=".$filter_order_Dir:'');
					echo $pagenav->writePagesLinks($link);
					echo "<br /><br />".$pagenav->writePagesCounter();
				}
				?>
		</div>
		<?php
	}

	/**
     * Shows main image
     */
	function showDisplayImage(){
		global $rsgConfig, $mosConfig_live_site;

		$item = rsgInstance::getItem();
		galleryUtils::addHit($item->id);

		if( $item->type != 'image' ){
			// item is not an image, return;
			return;
		}

// 		$this->writeSLideShowLink();

		if( $rsgConfig->get('displayPopup') == 2 ){
			$doc =& JFActory::getDocument();
			$doc->addStyleSheet(JPATH_BASE."/components/com_rsgallery2/js_highslide/highslide.css");
			$doc->addScript(JPATH_BASE."/components/com_rsgallery2/js_highslide/highslide.js");
			?>
			<script type="text/javascript">
				hs.graphicsDir = '<?php echo $mosConfig_live_site;?>/components/com_rsgallery2/js_highslide/graphics/';
				hs.showCredits = false;
				hs.outlineType = 'drop-shadow';
				window.onload = function() {
					hs.preloadImages();
				}
			</script>
			<?php
		}
		?>
		<div class="contentheading"><?php echo htmlspecialchars(stripslashes($item->title), ENT_QUOTES); ?></div>
				<div class="rsg2-ja-image">
					<div id="highslide-container" class="rsg2-galleryList-thumb2">
					<?php
					switch ($rsgConfig->get('displayPopup')) {
						//No popup
						case 0:
							$this->_showImageBox( $item->name, $item->descr );
							break;
						//Normal popup
						case 1:
							if ($rsgConfig->get('watermark')) {
								?><a href="<?php echo waterMarker::showMarkedImage( $item->name, 'original' ); ?>" target="_blank"><?php
							} else {
								?><a href="<?php echo imgUtils::getImgOriginal( $item->name ); ?>" target="_blank" rel="lightbox"><?php
							}
							$this->_showImageBox( $item->name, $item->descr );
							?>
							</a>
							<?php
							break;
						//Highslide popup
						case 2:
							if ($rsgConfig->get('watermark')) {
								?><a href="<?php echo waterMarker::showMarkedImage( $item->name, 'original'); ?>" class="highslide" onclick="return hs.expand(this)"><?php
							} else {
								?><a href="<?php echo imgUtils::getImgOriginal( $item->name ); ?>" class="highslide" onclick="return hs.expand(this)" ><?php
							}
							$this->_showImageBox( $item->name, $item->descr );
							?>
							</a>
							<?php
							break;
					}
					?>
					</div>
				</div>
		<?php
	}

	/**
	 * Show page navigation for Display image
	 */
	function showDisplayPageNav() {
		$gallery = rsgGalleryManager::get();
		$database=JFactory::getDBO();
		if( rsgInstance::getInt( 'id', 0 )){
			//  if id is set then we need to set limits and gid so that page nav works properlly
			rsgInstance::setVar( 'gid', $gallery->id );
			rsgInstance::setVar( 'limit', 1 );

			$item = $gallery->getItem();
			
			//tungps add here
			//Get ordering of image in gallery
			$sql="SELECT * FROM #__rsgallery2_files WHERE gallery_id='$item->gallery_id' AND published=1 ORDER BY ordering ASC";
            $database->setQuery($sql);
           
            $cols=$database->LoadObjectList();
            $ps=0;
            for ($m=0;$m<count($cols);$m++){
            	if ($cols[$m]->id==$item->id){
            		$ps=$m;
            		
            	}
            }
			rsgInstance::setVar( 'limitstart', $ps );
			//rsgInstance::setVar( 'limitstart', $item->ordering-1 );
		}

		$pageNav = $gallery->getPagination();
		$pageLinks = $pageNav->getPagesLinks();

		if( rsgInstance::getInt( 'id', 0 )){
			// i'm not fond of this style of hackery
			// first we need to replace the item id with the gallery id
			// second, the limit parameter is not being written.  this is must be a bug or something.  weird.
			$pageLinks = str_replace( ";id={$item->id}", ";gid={$gallery->id}&amp;limit=1", $pageLinks );
		}

		?>
		<div align="center">
			<?php echo $pageLinks; ?>
		</div>
		<?php
	}

	/**
	 * Shows details of image
	 */
	function showDisplayImageDetails() {
		$this->display('details.php');
	}

	/**
	 * Shows details of image
	 */
	function showDisplayImgTool() {
		$this->display('imagestool.php');
	}

 	/**
	 * Shows details of image
	 */
	function showDisplayImageComment() {
		$this->display('comment.php');
	}

   /**
     * Show description
     */
	function _showDescription( ) {
		global $rsgConfig;
		$item = rsgInstance::getItem();

/*		if( $rsgConfig->get('displayHits')):
		?>
		<p class="rsg2_hits"><?php echo _RSGALLERY_CATHITS; ?> <span><?php echo $item->hits; ?></span></p>
		<?php
		endif;
*/
		if ( $item->descr ):
		?>
		<?php  echo $item->descr; ?>
		<?php
		endif;
	}

    /**
     * @todo work with the new rsgCommenting system
     */
    function _showVoting() {
        global $rsgConfig;
        return;
        ?>
        <script type="text/javascript">
			//<![CDATA[
            function deleteComment(id) {
                var yesno = confirm ('<?php echo _RSGALLERY_COMMENT_DELETE;?>');
                if (yesno == true) {
                    location = '<?php JRoute::_("index.php?option=com_rsgallery2&page=delete_comment&amp;id=", false);?>'+id+'';
                }
            }
			//]]>
            </script>
        <table width="100%" border="0" cellpadding="0" cellspacing="1" class="adminForm">
		<tr>
			<td><?php $this->_writeDownloadLink( $item->id );?></td>
		</tr>
        <tr><td>
		<?php
		if( $rsgConfig->get('displayHits')):
		?>
		<p class="rsg2_hits"><?php echo _RSGALLERY_CATHITS; ?> <span><?php echo $item->hits; ?></span></p>
		<?php
		endif;
		?>
		</td></tr>
        <tr><td>
            <table width="100%" cellpadding="2" cellspacing="1">
                <form method="post" action="<?php global $Itemid; echo sefRelToAbs("index.php?option=com_rsgallery2&amp;Itemid=$Itemid&amp;page=vote"); ?>">
                <tr>
                        <td colspan="1" width="100"><strong><?php echo _RSGALLERY_VOTES_NR; ?>:</strong></td>
                        <td colspan="4"><?php echo $this->item['votes']; ?></td>
                </tr>
                <tr>
                    <td colspan="1"><strong><?php echo _RSGALLERY_VOTES_AVG; ?>:</strong></td>
                    <td colspan="4"><?php if ($this->item['votes'] > 0) echo galleryUtils::showRating( $this->item['id'] );else echo _RSGALLERY_NO_RATINGS; ?></td>
                </tr>
                <tr>
                    <input type="hidden" name="picid" value="<?php echo $this->item['id']; ?>" />
                    <input type="hidden" name="limitstart" value="<?php echo $this->limitstart; ?>" />
                    <td valign="top"><strong><?php echo _RSGALLERY_VOTE; ?>:</strong></td>
                    <td colspan="4">
                        <input type="radio" name="vote" value="1" /><?php echo _RSGALLERY_VERYBAD; ?><br />
                        <input type="radio" name="vote" value="2" /><?php echo _RSGALLERY_BAD; ?><br />
                        <input type="radio" name="vote" value="3" CHECKED/><?php echo _RSGALLERY_OK; ?><br />
                        <input type="radio" name="vote" value="4" /><?php echo _RSGALLERY_GOOD; ?><br />
                        <input type="radio" name="vote" value="5" /><?php echo _RSGALLERY_VERYGOOD; ?>
                    </td>
                </tr>
                <tr>
                    <td colspan="5" align="center"><input class="button" type="submit" name="submit" value="<?php echo _RSGALLERY_VOTE;?>" /></td>
                </tr>
                </form>
            </table>
        </td></tr>
        </table>
        <?php
    }

/*
    function _showVoting() {
        global $rsgConfig;

        return;
        ?>
        <script type="text/javascript">
			//<![CDATA[
            function deleteComment(id) {
                var yesno = confirm ('<?php echo _RSGALLERY_COMMENT_DELETE;?>');
                if (yesno == true) {
                    location = '<?php JRoute::_("index.php?option=com_rsgallery2&page=delete_comment&amp;id=", false);?>'+id+'';
                }
            }
			//]]>
            </script>
        <table width="100%" border="0" cellpadding="0" cellspacing="1" class="adminForm">
        <tr><td>
            <table width="100%" cellpadding="2" cellspacing="1">
                <form method="post" action="<?php global $Itemid; echo sefRelToAbs("index.php?option=com_rsgallery2&amp;Itemid=$Itemid&amp;page=vote"); ?>">
                <tr>
                        <td colspan="1" width="100"><strong><?php echo _RSGALLERY_VOTES_NR; ?>:</strong></td>
                        <td colspan="4"><?php echo $this->item['votes']; ?></td>
                </tr>
                <tr>
                    <td colspan="1"><strong><?php echo _RSGALLERY_VOTES_AVG; ?>:</strong></td>
                    <td colspan="4"><?php if ($this->item['votes'] > 0) echo galleryUtils::showRating( $this->item['id'] );else echo _RSGALLERY_NO_RATINGS; ?></td>
                </tr>
                <tr>
                    <input type="hidden" name="picid" value="<?php echo $this->item['id']; ?>" />
                    <input type="hidden" name="limitstart" value="<?php echo $this->limitstart; ?>" />
                    <td valign="top"><strong><?php echo _RSGALLERY_VOTE; ?>:</strong></td>
                    <td colspan="4">
                        <input type="radio" name="vote" value="1" /><?php echo _RSGALLERY_VERYBAD; ?><br />
                        <input type="radio" name="vote" value="2" /><?php echo _RSGALLERY_BAD; ?><br />
                        <input type="radio" name="vote" value="3" CHECKED/><?php echo _RSGALLERY_OK; ?><br />
                        <input type="radio" name="vote" value="4" /><?php echo _RSGALLERY_GOOD; ?><br />
                        <input type="radio" name="vote" value="5" /><?php echo _RSGALLERY_VERYGOOD; ?>
                    </td>
                </tr>
                <tr>
                    <td colspan="5" align="center"><input class="button" type="submit" name="submit" value="<?php echo _RSGALLERY_VOTE;?>" /></td>
                </tr>
                </form>
            </table>
        </td></tr>
        </table>
        <?php
    }

*/	/**
	 * shows exif data for the current item
	 */
	function _showEXIF( ) {
		$image = rsgInstance::getItem();

		// EXIF only available for images
		if( $image->type != 'image' )
			return;

		$exif = $image->exif();

		// no exif found display nothing.
		if( !$exif )
			return;

		$this->exif = $exif;

		$this->display('exif.php');
	}

    /**
     * Shows random images for display on main page
     */
    function showRandom( $style = "hor", $count = 3 ) {
        global $database, $rsgConfig;
        if ( $rsgConfig->get('displayRandom') ) {
            $catid = rsgInstance::getInt( 'catid', 0 );
            if (!$catid) {
                $database->setQuery("SELECT file.gallery_id, file.ordering, file.id, file.name, file.descr".
                                " FROM #__rsgallery2_files file, #__rsgallery2_galleries gal".
                                " WHERE file.gallery_id=gal.id and gal.published=1".
                                " ORDER BY rand() limit $count");
                $rows = $database->loadObjectList();
                HTML_RSGALLERY::showRandom($rows, $style);
            }
        }
    }

    /**
     * Shows latest uploaded images for display on main page
     */
    function showLatest( $style = "hor", $count = 3) {
        global $database, $rsgConfig;
        if ( $rsgConfig->get('displayLatest') ) {
            $catid = rsgInstance::getInt( 'catid', 0 );
            if (!$catid) {
                $database->setQuery("SELECT file.gallery_id, file.ordering, file.id, file.name, file.descr".
                                " FROM #__rsgallery2_files file, #__rsgallery2_galleries gal".
                                " WHERE file.gallery_id=gal.id and gal.published=1".
                                " ORDER BY file.date DESC limit $count");
                $rows = $database->loadObjectList();
                HTML_RSGALLERY::showLatest($rows);
            }
        }
    }

    function showRSTopBar() {
        global $my, $mosConfig_live_site, $rsgConfig, $Itemid;
        $catid =rsgInstance::getInt( 'catid', 0 );
        $Itemid = rsgInstance::getInt( 'Itemid', 0 );
        $page = rsgInstance::getVar( 'page'  , null);
        ?>
        <div style="float:right; text-align:right;">
        <ul id='rsg2-navigation'>
            <li>
                <a href="<?php echo sefRelToAbs("index.php?option=com_rsgallery2&amp;Itemid=".$Itemid); ?>">
                <?php echo _RSGALLERY_MAIN_GALLERY_PAGE;
                ?>
                </a>
            </li>
            <?php
            if ( !$my->id == "" && $page != "my_galleries" && $rsgConfig->get('show_mygalleries') == 1):
            ?>
            <li>
                <a href="<?php echo sefRelToAbs("index.php?option=com_rsgallery2&Itemid=".$Itemid."&page=my_galleries");?>">
                <?php echo _RSGALLERY_MY_GALLERIES;?>
                </a>
            </li>
            <?php
            elseif( $page == "slideshow" ):
            ?>
            <li>
                <a href="<?php echo sefRelToAbs("index.php?option=com_rsgallery2&Itemid=".$Itemid."&page=inline&catid=".$catid."&amp;id=".$_GET['id']);?>">
                <?php echo _RSGALLERY_SLIDESHOW_EXIT; ?>
                </a>
            </li>
        <?php endif; ?>
        </ul>
        </div>
        <div style="float:left;">
        <?php if( isset( $catid )): ?>
            <h2 id='rsg2-galleryTitle'><?php htmlspecialchars(stripslashes(galleryUtils::getCatNameFromId($catid)), ENT_QUOTES) ?></h2>
        <?php elseif( $page != "my_galleries" ): ?>
            <h2 id='rsg2-galleryTitle'><?php echo _RSGALLERY_COMPONENT_TITLE ?></h2>
        <?php endif; ?>
        </div>
        <?php
    }

	/**
	 * Write downloadlink for image
	 * @param int image ID
	 * @param string Button or HTML link (button/link)
	 * @return HTML for downloadlink
	 */
	function _writeDownloadLink($id, $showtext = true, $type = 'button') {
	global $rsgConfig, $mosConfig_live_site;
	if ( $rsgConfig->get('displayDownload') ) {
		echo "<div class=\"rsg2-toolbar\">";
		if ($type == 'button') {
			?>
			<a href="<?php echo sefRelToAbs('index.php?option=com_rsgallery2&amp;task=downloadfile&amp;id='.$id);?>">
			<img src="<?php echo $mosConfig_live_site;?>/administrator/images/download_f2.png" alt="<?php echo _RSGALLERY_DOWNLOAD?>" />
			<?php
			if ($showtext == true) {
				?>
				<br /><span style="font-size:smaller;"><?php echo _RSGALLERY_DOWNLOAD?></span>
				<?php
			}
			?>
			</a>
			<?php
		} else {
			?>
			<a href="<?php echo sefRelToAbs('index.php?option=com_rsgallery2&amp;task=downloadfile&amp;id='.$id);?>"><?php echo _RSGALLERY_DOWNLOAD?></a>
			<?php
		}
		echo "</div>";
		}
	}


	/**
	* list sub galleries in a gallery
	* @param rsgGallery parent gallery
	*/
	function _subGalleryList( $parent ){
		global $Itemid;
		$kids = $parent->kids();

		if( count( $kids ) == 0 ) return;

		echo "Subgalleries: ";

		$kid = array_shift( $kids );

		while( true ){
			?>
			<a href="<?php echo sefRelToAbs("index.php?option=com_rsgallery2&amp;Itemid=$Itemid&amp;catid=".$kid->id); ?>">
				<?php echo htmlspecialchars(stripslashes($kid->name), ENT_QUOTES); ?>
				(<?php echo $kid->itemCount(); ?>)</a><?php

			if( $kid = array_shift( $kids ))
				echo ', ';
			else
				break;
		}
	}

}


/**
 * HTML for the frontend
 * @package RSGallery2
 */
class HTML_RSGALLERY{


    function showUserGallery($rows)
    {
    global $my, $rsgConfig, $mosConfig_live_site, $Itemid;
    //Load frontend toolbar class
    require_once( $GLOBALS['mosConfig_absolute_path'] . '/includes/HTML_toolbar.php' );
    ?>
    <script type="text/javascript">
        function submitbutton(pressbutton) {
            var form = document.form1;
            if (pressbutton == 'cancel') {
                form.reset();
                return;
            }

        // do field validation
        if (form.catname1.value == "") {
            alert( "<?php echo _RSGALLERY_MAKECAT_ALERT_NAME; ?>" );
        }
        else if (form.description.value == ""){
            alert( "<?php echo _RSGALLERY_MAKECAT_ALERT_DESCR; ?>" );
        }
        else{
            <?php //getEditorContents( 'editor1', 'description' ) ; ?>
            form.submit();
        }
        }
    </script>
    <?php
    if ($rows) {
        foreach ($rows as $row){
            $catname        = $row->name;
            $description    = $row->description;
            $ordering       = $row->ordering;
            $uid            = $row->uid;
            $catid          = $row->id;
            $published      = $row->published;
            $user           = $row->user;
            $parent         = $row->parent;
        }
    }
    else{
        $catname        = "";
        $description    = "";
        $ordering       = "";
        $uid            = "";
        $catid          = "";
        $published      = "";
        $user           = "";
        $parent         = "";
    }
    ?>
        <form name="form1" id="form1" method="post" action="<?php echo sefRelToAbs("index.php?option=com_rsgallery2&amp;Itemid=$Itemid&amp;page=makeusercat"); ?>">
        <table width="100%">
        <tr>
            <td colspan="2"><h3><?php echo _RSGALLERY_CREATE_GALLERY; ?></h3></td>
        </tr>
        <tr>

            <td align="right">
                <div style="float: right;">
                        <?php
                        // Toolbar
                        mosToolBar::startTable();
                        mosToolBar::save();
                        mosToolBar::cancel();
                        mosToolBar::endtable();
                        ?>
                </div>
            </td>

        </tr>
        </table>
        <input type="hidden" name="catid" value="<?php echo $catid; ?>" />
        <input type="hidden" name="ordering" value="<?php echo $ordering; ?>" />
        <table class="adminlist" border="1">
        <tr>
            <th colspan="2"><?php echo _RSGALLERY_CREATE_GALLERY; ?></th>
        </tr>
        <tr>
            <td><?php echo _RSGALLERY_CATLEVEL;?></td>
            <td>
                <?php //galleryUtils::showCategories(NULL, $my->id, 'parent');?>
                <?php echo galleryUtils::galleriesSelectList( $parent, 'parent', false );?>
                <?php //galleryUtils::createGalSelectList( NULL, $listName='parent', true );?>
            </td>
        </tr>
        <tr>
            <td><?php echo _RSGALLERY_USERCAT_NAME; ?></td>
            <td align="left"><input type="text" name="catname1" size="30" value="<?php echo $catname; ?>" /></td>
        </tr>
        <tr>
            <td><?php echo _RSGALLERY_DESCR; ?></td>
            <td align="left">
                <textarea cols="20" rows="5" name="description"><?php echo htmlspecialchars(stripslashes($description)); ?></textarea>
                <?php
                // parameters : areaname, content, hidden field, width, height, rows, cols
                //editorArea( 'editor1',  $description , 'description', '200', '300', '10', '10' ) ; ?>
            </td>
        </tr>
        <tr>
            <td><?php echo _RSGALLERY_CATPUBLISHED; ?></td>
            <td align="left"><input type="checkbox" name="published" value="1" <?php if ($published==1) echo "checked"; ?> /></td>
        </tr>
        </table>
        </form>
        <?php
	}

    function edit_image($rows)
	{
		$this->_rows = $rows;
		$this->display( 'editimage.php' );
	}


    function showFrontUpload()
	{
		$this->display( 'frontupload.php' );
	}


    /**
     * Shows header with appropriate links at top of each rsgallery page
     * @param integer category ID. Used to echo category name if present
     * @param string intro text to show on main gallery page.
     * @todo Rewrite this into cleaner coding style.
     */
    function RSGalleryTitleblock($catid, $intro_text)   {
        global $my, $mosConfig_live_site, $rsgConfig, $Itemid;
        $page = rsgInstance::getVar( 'page'  , null);

        //$user_cats  = $rsgConfig->get('uu_enabled');
        //$my_galleries = $rsgConfig->get('show_mygalleries');
        ?>
        <div style="float:right; text-align:right;">
        <ul id='rsg2-navigation'>
            <li>
                <a href="<?php echo sefRelToAbs("index.php?option=com_rsgallery2&amp;Itemid=".$Itemid); ?>">
                <?php echo _RSGALLERY_MAIN_GALLERY_PAGE; ?>
                </a>
            </li>
            <?php
            if ( !$my->id == "" && $page != "my_galleries" && $rsgConfig->get('show_mygalleries') == 1):
            ?>
            <li>
                <a href="<?php echo sefRelToAbs("index.php?option=com_rsgallery2&Itemid=".$Itemid."&page=my_galleries");?>">
                <?php echo _RSGALLERY_MY_GALLERIES; ?>
                </a>
            </li>
            <?php
            elseif( $page == "slideshow" ):
            ?>
            <li>
                <a href="<?php echo sefRelToAbs("index.php?option=com_rsgallery2&Itemid=".$Itemid."&page=inline&catid=".$catid."&amp;id=".$_GET['id']);?>">
                <?php echo _RSGALLERY_SLIDESHOW_EXIT; ?>
                </a>
            </li>
        <?php endif; ?>
        </ul>
        </div>
        <div style="float:left;">
        <?php if( isset( $catid )): ?>
            <h2 id='rsg2-galleryTitle'><?php htmlspecialchars(stripslashes(galleryUtils::getCatNameFromId($catid)), ENT_QUOTES) ?></h2>
        <?php elseif( $page != "my_galleries" ): ?>
            <h2 id='rsg2-galleryTitle'><?php echo _RSGALLERY_COMPONENT_TITLE ?></h2>
        <?php endif; ?>
        <div id='rsg2-galleryIntroText'>
            <?php //echo htmlspecialchars(stripslashes($intro_text), ENT_QUOTES); ?>
            <?php echo stripslashes($intro_text); ?>
        </div>
        <?php
        ?>

        </div>
        <?php
    }


    /**
     * Shows thumbnails for gallery and links to subgalleries if they exist.
     * @param integer Category ID
     * @param integer Columns per page
     * @param integer Number of thumbs per page
     * @param integer pagenav stuff
     * @param integer pagenav stuff
     */
    function RSShowPictures ($catid, $limit, $limitstart){
        global $database, $my, $mosConfig_live_site, $rsgConfig;
        $columns                    = $rsgConfig->get("display_thumbs_colsPerPage");
        $PageSize                   = $rsgConfig->get("display_thumbs_maxPerPage");
        //$my_id                      = $my->id;

        $database->setQuery("SELECT COUNT(1) FROM #__rsgallery2_files WHERE gallery_id='$catid'");
        $numPics = $database->loadResult();

        if(!isset($limitstart))
            $limitstart = 0;
        //instantiate page navigation
        $pagenav = new mosPageNav($numPics, $limitstart, $PageSize);

        $picsThisPage = min($PageSize, $numPics - $limitstart);

        if (!$picsThisPage == 0)
                $columns = min($picsThisPage, $columns);

        //Add a hit to the database
        if ($catid && !$limitstart)
            {
            galleryUtils::addCatHit($catid);
            }
        //Old rights management. If user is owner or user is Super Administrator, you can edit this gallery
        if(( $my->id <> 0 ) and (( galleryUtils::getUID( $catid ) == $my->id ) OR ( $my->usertype == 'Super Administrator' )))
            $allowEdit = true;
        else
            $allowEdit = false;

        $thumbNumber = 0;

        if ($picsThisPage) {
			$database->setQuery("SELECT * FROM #__rsgallery2_files".
								" WHERE gallery_id='$catid'".
								" ORDER BY ordering ASC".
								" LIMIT $limitstart, $PageSize");
			$this->_rows = $database->loadObjectList();

			$this->display( 'pictures.php' );
        } else {
            if (!$catid == 0) echo _RSGALLERY_NOIMG;
        }
   }


    function showMyGalleries($rows) {
		$this->_rows = $rows;
		$this->display( 'mygalleries.php' );
    }

    /**
     * This will show the images, available to the logged in users in the My Galleries screen
     * under the tab "My Images".
     * @param array Result array with image details for the logged in users
     * @param array Result array with pagenav details
     */
    function showMyImages($images, $pageNav) {
		$this->_images = $images;
		$this->_pageNav = $pageNav;
		$this->display( 'myimages.php' );
    }

    /**
     * Displays details about the logged in user and the privileges he/she has
     * $param integer User ID from Joomla user table
     */
     function RSGalleryUserInfo($id) {
		$this->_id = $id;
		$this->display( 'userinfo.php' );
     }

    /**
     * This presents the main My Galleries page
     * @param array Result array with category details for logged in users
     * @param array Result array with image details for logged in users
     * @param array Result array with pagenav information
     */
    function myGalleries($rows, $images, $pageNav)
        {
        global $rsgConfig, $my, $database, $mosConfig_live_site, $Itemid, $mainframe;
        if (!$rsgConfig->get('show_mygalleries'))
            mosRedirect( sefRelToAbs("index.php?option=com_rsgallery2&amp;Itemid=$Itemid"),_RSGALLERY_USERGAL_DISABLED);
			$mainframe->appendPathWay(_RSGALLERY_USER_MY_GAL);
        ?>
        <div class="componentheading"><?php echo _RSGALLERY_USER_MY_GAL;?></div>
		<div id="rsg2-main" class="clearfix">
        <?php
        //Show User information
        HTML_RSGALLERY::RSGalleryUSerInfo($my->id);
        //Start tabs
		HTML_RSGALLERY::showMyImages($images, $pageNav);
		HTML_RSGALLERY::showFrontUpload();

		if ($rsgConfig->get('uu_createCat')) {
			HTML_RSGALLERY::showMyGalleries($rows);
			HTML_RSGALLERY::showUserGallery(NULL);
        }
        ?>
		</div>
        <div class='rsg2-clr'>&nbsp;</div>
		<?php
    
	}

    function showRandom($rows, $style = "hor") {
		$this->_rows = $rows;
		$this->_style = $style;
		$this->display( 'random.php' );
    }

	function showLatest($rows, $style = "hor") {
		$this->_rows = $rows;
		$this->_style = $style;
		$this->display( 'latest.php' );
    }

} //end class